// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from foxglove_msgs:msg/ImageMarkerArray.idl
// generated code does not contain a copyright notice
#include "foxglove_msgs/msg/detail/image_marker_array__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `markers`
#include "visualization_msgs/msg/detail/image_marker__functions.h"

bool
foxglove_msgs__msg__ImageMarkerArray__init(foxglove_msgs__msg__ImageMarkerArray * msg)
{
  if (!msg) {
    return false;
  }
  // markers
  if (!visualization_msgs__msg__ImageMarker__Sequence__init(&msg->markers, 0)) {
    foxglove_msgs__msg__ImageMarkerArray__fini(msg);
    return false;
  }
  return true;
}

void
foxglove_msgs__msg__ImageMarkerArray__fini(foxglove_msgs__msg__ImageMarkerArray * msg)
{
  if (!msg) {
    return;
  }
  // markers
  visualization_msgs__msg__ImageMarker__Sequence__fini(&msg->markers);
}

bool
foxglove_msgs__msg__ImageMarkerArray__are_equal(const foxglove_msgs__msg__ImageMarkerArray * lhs, const foxglove_msgs__msg__ImageMarkerArray * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // markers
  if (!visualization_msgs__msg__ImageMarker__Sequence__are_equal(
      &(lhs->markers), &(rhs->markers)))
  {
    return false;
  }
  return true;
}

bool
foxglove_msgs__msg__ImageMarkerArray__copy(
  const foxglove_msgs__msg__ImageMarkerArray * input,
  foxglove_msgs__msg__ImageMarkerArray * output)
{
  if (!input || !output) {
    return false;
  }
  // markers
  if (!visualization_msgs__msg__ImageMarker__Sequence__copy(
      &(input->markers), &(output->markers)))
  {
    return false;
  }
  return true;
}

foxglove_msgs__msg__ImageMarkerArray *
foxglove_msgs__msg__ImageMarkerArray__create()
{
  foxglove_msgs__msg__ImageMarkerArray * msg = (foxglove_msgs__msg__ImageMarkerArray *)malloc(sizeof(foxglove_msgs__msg__ImageMarkerArray));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(foxglove_msgs__msg__ImageMarkerArray));
  bool success = foxglove_msgs__msg__ImageMarkerArray__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
foxglove_msgs__msg__ImageMarkerArray__destroy(foxglove_msgs__msg__ImageMarkerArray * msg)
{
  if (msg) {
    foxglove_msgs__msg__ImageMarkerArray__fini(msg);
  }
  free(msg);
}


bool
foxglove_msgs__msg__ImageMarkerArray__Sequence__init(foxglove_msgs__msg__ImageMarkerArray__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  foxglove_msgs__msg__ImageMarkerArray * data = NULL;
  if (size) {
    data = (foxglove_msgs__msg__ImageMarkerArray *)calloc(size, sizeof(foxglove_msgs__msg__ImageMarkerArray));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = foxglove_msgs__msg__ImageMarkerArray__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        foxglove_msgs__msg__ImageMarkerArray__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
foxglove_msgs__msg__ImageMarkerArray__Sequence__fini(foxglove_msgs__msg__ImageMarkerArray__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      foxglove_msgs__msg__ImageMarkerArray__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

foxglove_msgs__msg__ImageMarkerArray__Sequence *
foxglove_msgs__msg__ImageMarkerArray__Sequence__create(size_t size)
{
  foxglove_msgs__msg__ImageMarkerArray__Sequence * array = (foxglove_msgs__msg__ImageMarkerArray__Sequence *)malloc(sizeof(foxglove_msgs__msg__ImageMarkerArray__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = foxglove_msgs__msg__ImageMarkerArray__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
foxglove_msgs__msg__ImageMarkerArray__Sequence__destroy(foxglove_msgs__msg__ImageMarkerArray__Sequence * array)
{
  if (array) {
    foxglove_msgs__msg__ImageMarkerArray__Sequence__fini(array);
  }
  free(array);
}

bool
foxglove_msgs__msg__ImageMarkerArray__Sequence__are_equal(const foxglove_msgs__msg__ImageMarkerArray__Sequence * lhs, const foxglove_msgs__msg__ImageMarkerArray__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!foxglove_msgs__msg__ImageMarkerArray__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
foxglove_msgs__msg__ImageMarkerArray__Sequence__copy(
  const foxglove_msgs__msg__ImageMarkerArray__Sequence * input,
  foxglove_msgs__msg__ImageMarkerArray__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(foxglove_msgs__msg__ImageMarkerArray);
    foxglove_msgs__msg__ImageMarkerArray * data =
      (foxglove_msgs__msg__ImageMarkerArray *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!foxglove_msgs__msg__ImageMarkerArray__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          foxglove_msgs__msg__ImageMarkerArray__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!foxglove_msgs__msg__ImageMarkerArray__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
