// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from foxglove_msgs:msg/CompressedImage.idl
// generated code does not contain a copyright notice
#include "foxglove_msgs/msg/detail/compressed_image__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `timestamp`
#include "builtin_interfaces/msg/detail/time__functions.h"
// Member `data`
#include "rosidl_runtime_c/primitives_sequence_functions.h"
// Member `format`
#include "rosidl_runtime_c/string_functions.h"

bool
foxglove_msgs__msg__CompressedImage__init(foxglove_msgs__msg__CompressedImage * msg)
{
  if (!msg) {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__init(&msg->timestamp)) {
    foxglove_msgs__msg__CompressedImage__fini(msg);
    return false;
  }
  // data
  if (!rosidl_runtime_c__uint8__Sequence__init(&msg->data, 0)) {
    foxglove_msgs__msg__CompressedImage__fini(msg);
    return false;
  }
  // format
  if (!rosidl_runtime_c__String__init(&msg->format)) {
    foxglove_msgs__msg__CompressedImage__fini(msg);
    return false;
  }
  return true;
}

void
foxglove_msgs__msg__CompressedImage__fini(foxglove_msgs__msg__CompressedImage * msg)
{
  if (!msg) {
    return;
  }
  // timestamp
  builtin_interfaces__msg__Time__fini(&msg->timestamp);
  // data
  rosidl_runtime_c__uint8__Sequence__fini(&msg->data);
  // format
  rosidl_runtime_c__String__fini(&msg->format);
}

bool
foxglove_msgs__msg__CompressedImage__are_equal(const foxglove_msgs__msg__CompressedImage * lhs, const foxglove_msgs__msg__CompressedImage * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->timestamp), &(rhs->timestamp)))
  {
    return false;
  }
  // data
  if (!rosidl_runtime_c__uint8__Sequence__are_equal(
      &(lhs->data), &(rhs->data)))
  {
    return false;
  }
  // format
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->format), &(rhs->format)))
  {
    return false;
  }
  return true;
}

bool
foxglove_msgs__msg__CompressedImage__copy(
  const foxglove_msgs__msg__CompressedImage * input,
  foxglove_msgs__msg__CompressedImage * output)
{
  if (!input || !output) {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->timestamp), &(output->timestamp)))
  {
    return false;
  }
  // data
  if (!rosidl_runtime_c__uint8__Sequence__copy(
      &(input->data), &(output->data)))
  {
    return false;
  }
  // format
  if (!rosidl_runtime_c__String__copy(
      &(input->format), &(output->format)))
  {
    return false;
  }
  return true;
}

foxglove_msgs__msg__CompressedImage *
foxglove_msgs__msg__CompressedImage__create()
{
  foxglove_msgs__msg__CompressedImage * msg = (foxglove_msgs__msg__CompressedImage *)malloc(sizeof(foxglove_msgs__msg__CompressedImage));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(foxglove_msgs__msg__CompressedImage));
  bool success = foxglove_msgs__msg__CompressedImage__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
foxglove_msgs__msg__CompressedImage__destroy(foxglove_msgs__msg__CompressedImage * msg)
{
  if (msg) {
    foxglove_msgs__msg__CompressedImage__fini(msg);
  }
  free(msg);
}


bool
foxglove_msgs__msg__CompressedImage__Sequence__init(foxglove_msgs__msg__CompressedImage__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  foxglove_msgs__msg__CompressedImage * data = NULL;
  if (size) {
    data = (foxglove_msgs__msg__CompressedImage *)calloc(size, sizeof(foxglove_msgs__msg__CompressedImage));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = foxglove_msgs__msg__CompressedImage__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        foxglove_msgs__msg__CompressedImage__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
foxglove_msgs__msg__CompressedImage__Sequence__fini(foxglove_msgs__msg__CompressedImage__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      foxglove_msgs__msg__CompressedImage__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

foxglove_msgs__msg__CompressedImage__Sequence *
foxglove_msgs__msg__CompressedImage__Sequence__create(size_t size)
{
  foxglove_msgs__msg__CompressedImage__Sequence * array = (foxglove_msgs__msg__CompressedImage__Sequence *)malloc(sizeof(foxglove_msgs__msg__CompressedImage__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = foxglove_msgs__msg__CompressedImage__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
foxglove_msgs__msg__CompressedImage__Sequence__destroy(foxglove_msgs__msg__CompressedImage__Sequence * array)
{
  if (array) {
    foxglove_msgs__msg__CompressedImage__Sequence__fini(array);
  }
  free(array);
}

bool
foxglove_msgs__msg__CompressedImage__Sequence__are_equal(const foxglove_msgs__msg__CompressedImage__Sequence * lhs, const foxglove_msgs__msg__CompressedImage__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!foxglove_msgs__msg__CompressedImage__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
foxglove_msgs__msg__CompressedImage__Sequence__copy(
  const foxglove_msgs__msg__CompressedImage__Sequence * input,
  foxglove_msgs__msg__CompressedImage__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(foxglove_msgs__msg__CompressedImage);
    foxglove_msgs__msg__CompressedImage * data =
      (foxglove_msgs__msg__CompressedImage *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!foxglove_msgs__msg__CompressedImage__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          foxglove_msgs__msg__CompressedImage__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!foxglove_msgs__msg__CompressedImage__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
